using Exferia_Aplicacion.General;
using Exferia_Aplicacion.Visualizacion;
using Exferia_Controles;
using Exferia_EntityFramework;
using Exferia_General;
using Exferia_GestionDocumental._0_Modelos;
using Exferia_GestionDocumental._3_Vistas.Controladoras;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Linq;
using System.IO;
using System.Diagnostics;

namespace Exferia_GestionDocumental._3_Vistas
{
    public partial class P_ProcesoRellenarDatosEtiquetas : Exferia_Formularios.P_Base_Mantenimientos
    {
        #region Variables Generales
        private P_ProcesoRellenarDatosEtiquetas_Controladora g_obj_Controladora;

        private bool g_bol_ConstructorPantalla_Terminado_Correctamente = true;

        public PRV_OpcionesDetalle g_mdl_PRV_OpcionesDetalle = null;
        internal List<INTERNO_Permisos_Modelo> g_lst_INTERNO_Permisos_Modelo = null;
        #endregion

        #region Objetos en Pantalla

        //Exferia_DataGridView
        internal Exferia_DataGridView Exferia_DataGridView_Documentos { get { return ex_dgv_P_ProcesoRellenarDatosEtiquetas_Documentos; } }

        //Exferia_Label_SinColor
        internal Exferia_Label_SinColor Exferia_Label_SinColor_Total { get { return ex_lbl_P_ProcesoRellenarDatosEtiquetas_Total; } }

        //Exferia_Panel_Degradado
        internal Exferia_Panel_Degradado Exferia_Panel_Degradado_Etiquetas { get { return ex_pnl_P_ProcesoRellenarDatosEtiquetas_Etiquetas; } }
        
        #endregion

        #region Constructor
        public P_ProcesoRellenarDatosEtiquetas(INTERNO_ValoresGenerales_Modelo _mdl_INTERNO_ValoresGenerales_Modelo,
                                                DateTime _dtt_FechaTrabajo,
                                                PRV_OpcionesDetalle _mdl_PRV_OpcionesDetalle)
        {
            InitializeComponent();

            try
            {
                Repintar.Empezar(this);

                CheckForIllegalCrossThreadCalls = false;

                //Empresa seleccionada y fecha de trabajo ....................................................
                P_Base_ValoresGenerales = _mdl_INTERNO_ValoresGenerales_Modelo;
                P_Base_FechaTrabajo = _dtt_FechaTrabajo;

                //Instanciar Controladora
                g_obj_Controladora = new P_ProcesoRellenarDatosEtiquetas_Controladora(this);

                //Datos de Opciones detalle
                g_mdl_PRV_OpcionesDetalle = _mdl_PRV_OpcionesDetalle;

                //Buscar los Permisos
                g_lst_INTERNO_Permisos_Modelo = Datos_Generales.Permisos_Buscar(g_mdl_PRV_OpcionesDetalle.opcion);

                //Titulo de la Pantalla .............................................................................
                P_Base_TituloPantalla = _mdl_PRV_OpcionesDetalle.descripcion_TituloMantenimiento;

                // Label con Empresa Seleccionada 
                if (P_Base_ValoresGenerales != null)
                {
                    try
                    {
                        P_Base_Mantenimientos_InformacionEmpresaSeleccionada = P_Base_ValoresGenerales.str_Empresa_Descripcion + " - " +
                                                               "(" + P_Base_FechaTrabajo.ToString("dd/MM/yyyy") + ")";
                    }
                    catch (Exception ex)
                    {
                        //No se muestra mensaje pero se guarda en el log
                        Control_Errores.Errores_Log("", ex, nameof(P_ProcesoRellenarDatosEtiquetas) + "/" + nameof(P_ProcesoRellenarDatosEtiquetas));
                    }
                }
                //....................................................................................................

                //Bloquear pantalla hasta que termine la carga por defecto .....
                Enabled = false;
            }
            catch (Control_Errores)
            {
                g_bol_ConstructorPantalla_Terminado_Correctamente = false;
            }
            catch (Exception ex)
            {
                g_bol_ConstructorPantalla_Terminado_Correctamente = false;

                //No se muestra mensaje pero se guarda en el log
                Control_Errores.Errores_Log("", ex, nameof(P_ProcesoRellenarDatosEtiquetas) + "/" + nameof(P_ProcesoRellenarDatosEtiquetas));
            }
            finally
            {
                //Bloquear pantalla hasta que termine la carga por defecto .....
                Enabled = true;
                //.............................................................
            }
        }

        #endregion

        #region Inicio de Pantalla
        private void P_ProcesoRellenarDatosEtiquetas_Shown(object sender, EventArgs e)
        {
            try
            {
                if (g_bol_ConstructorPantalla_Terminado_Correctamente)
                {
                    g_obj_Controladora.CargaInicial();
                }
                else
                {
                    Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_GENERAL_ERROR_CARGARDATOSPANTALLA());
                    Salir_P_Base();
                }
            }
            catch (Control_Errores)
            {
                Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_GENERAL_ERROR_CARGARDATOSPANTALLA());
                Salir_P_Base();
            }
            catch (Exception ex)
            {
                //No se muestra mensaje pero se guarda en el log
                Control_Errores.Errores_Log("", ex, nameof(P_ProcesoRellenarDatosEtiquetas) + "/" + nameof(P_ProcesoRellenarDatosEtiquetas_Shown));

                Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_GENERAL_ERROR_CARGARDATOSPANTALLA());
                Salir_P_Base();
            }
        }
        #endregion

        #region Listado
        private void ex_dgv_P_ProcesoRellenarDatosEtiquetas_Documentos_SelectionChanged(object sender, EventArgs e)
        {
            try
            {
                if (g_obj_Controladora != null)
                {
                    if (ex_dgv_P_ProcesoRellenarDatosEtiquetas_Documentos.Rows != null &&
                        ex_dgv_P_ProcesoRellenarDatosEtiquetas_Documentos.SelectedRows != null &&
                        ex_dgv_P_ProcesoRellenarDatosEtiquetas_Documentos.SelectedRows.Count > 0)
                    {
                        g_obj_Controladora.g_lng_IdDocumento_Seleccionado = long.Parse(ex_dgv_P_ProcesoRellenarDatosEtiquetas_Documentos.SelectedRows[0].Cells[g_obj_Controladora.g_int_PosicionColumna_Identificador].Value.ToString());
                        g_obj_Controladora.Rellenar_Listado_Etiquetas(g_obj_Controladora.g_lng_IdDocumento_Seleccionado);
                    }
                    else
                    {
                        //g_obj_Controladora.Vaciar();
                    }
                }
            }
            catch (Exception ex)
            {
                Control_Errores.Errores_Log("", ex, nameof(P_ProcesoRellenarDatosEtiquetas) + "/" + nameof(ex_dgv_P_ProcesoRellenarDatosEtiquetas_Documentos_SelectionChanged));
            }
        }

        private void ex_dgv_P_ProcesoRellenarDatosEtiquetas_Documentos_CellContentClick(object sender, DataGridViewCellEventArgs e)
        {
            try
            {
                //Boton Ver
                if (e.RowIndex >= 0 &&
                    ex_dgv_P_ProcesoRellenarDatosEtiquetas_Documentos.Rows[e.RowIndex].Cells[g_obj_Controladora.g_int_PosicionColumna_Boton_Ver] is DataGridViewButtonCell &&
                    e.ColumnIndex.Equals(g_obj_Controladora.g_int_PosicionColumna_Boton_Ver))
                {

                    INTERNO_Documentos_Listado_ProcesoParaRellenarEtiquetasModelo mdl_INTERNO_Documentos_Listado_ProcesoParaRellenarEtiquetasModelo = g_obj_Controladora.g_lst_INTERNO_Documentos_Listado_ProcesoParaRellenarEtiquetasModelo_FINAL.Where(m => m.Id == long.Parse(ex_dgv_P_ProcesoRellenarDatosEtiquetas_Documentos.Rows[e.RowIndex].Cells[g_obj_Controladora.g_int_PosicionColumna_Identificador].Value.ToString())).FirstOrDefault();
                    if (mdl_INTERNO_Documentos_Listado_ProcesoParaRellenarEtiquetasModelo != null)
                    {
                        //Buscar el Documento
                        byte[] arr_Documento=g_obj_Controladora.g_obj_GTD_Documentos_Archivos_Datos.Obtener(mdl_INTERNO_Documentos_Listado_ProcesoParaRellenarEtiquetasModelo.Id);

                        if (arr_Documento != null)
                        {
                            int int_Contador = 0;
                            bool bol_SeguirEjecutando = true;

                            while (bol_SeguirEjecutando)
                            {
                                try
                                {
                                    string str_Extension = ex_dgv_P_ProcesoRellenarDatosEtiquetas_Documentos.Rows[e.RowIndex].Cells[g_obj_Controladora.g_int_PosicionColumna_Extension].Value.ToString().ToLower();

                                    string str_Ficherotemporal = Path.GetTempPath() + @"Fichero_temporal_" + int_Contador + str_Extension;

                                    File.WriteAllBytes(str_Ficherotemporal, arr_Documento);

                                    Process obj_Process = new Process();
                                    obj_Process.StartInfo.FileName = str_Ficherotemporal;
                                    obj_Process.Start();

                                    bol_SeguirEjecutando = false;
                                }
                                catch
                                {
                                    int_Contador += 1;

                                    if (int_Contador == 20)
                                    {
                                        bol_SeguirEjecutando = false;
                                    }
                                }
                            }
                        }
                    }
                }
            }
            catch (Exception ex)
            {
                Control_Errores.Errores_Log("", ex, nameof(P_ProcesoRellenarDatosEtiquetas) + "/" + nameof(ex_dgv_P_ProcesoRellenarDatosEtiquetas_Documentos_CellContentClick));
            }
        }
        #endregion

        #region Grabar
        private void ex_btn_P_ProcesoRellenarDatosEtiquetas_Grabar_Click(object sender, EventArgs e)
        {
            g_obj_Controladora.ProcesoRellenarDatosEtiquetas(-1);
        }

        #endregion

        #region Actualizar
        private void ex_btn_P_ProcesoRellenarDatosEtiquetas_Actualizar_Click(object sender, EventArgs e)
        {
            if (g_obj_Controladora.g_lng_IdDocumento_Seleccionado>-1)
            {
                g_obj_Controladora.ProcesoRellenarDatosEtiquetas(g_obj_Controladora.g_lng_IdDocumento_Seleccionado);
            }
        }
        #endregion

        #region Borrar
        private void ex_btn_P_ProcesoRellenarDatosEtiquetas_Borrar_Click(object sender, EventArgs e)
        {
            if (g_obj_Controladora.g_lng_IdDocumento_Seleccionado > -1)
            {
                g_obj_Controladora.Borrar(g_obj_Controladora.g_lng_IdDocumento_Seleccionado);
            }
        }
        #endregion
    }
}
